package com.oe.tplayer_plugin;

import androidx.annotation.NonNull;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import android.content.Intent;
import android.app.Activity;
import android.net.Uri;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;

/** TplayerPlugin */
public class TplayerPlugin implements FlutterPlugin, MethodCallHandler, ActivityAware {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;
  private Activity activity;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "tplayer_plugin");
    channel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else if(call.method.equals("openTPlayer")) {
      try {
        String url = call.argument("url");
        String referer = call.argument("referer");
        String title = call.argument("title");
        String userAgent = call.argument("userAgent");
        if(activity != null) {
          Intent intent = new Intent(Intent.ACTION_MAIN);
          intent.setClassName("teavideo.tvplayer.videoallformat", "teavideo.tvplayer.videoallformat.player.PlayerActivity");
          intent.setDataAndType(Uri.parse(url), "application/x-mpegURL");
          intent.putExtra("referer", referer);
          intent.putExtra("user_agent", userAgent);
          intent.putExtra("source", "tealive");
          intent.putExtra(Intent.EXTRA_TITLE, title);
          activity.startActivity(intent);
        }
        result.success(1);
      } catch (Exception ex) {
        result.error("1", ex.getMessage(), ex.getStackTrace());
      }
    } else if(call.method.equals("openTPlayerNoLive")) {
      try {
        String url = call.argument("url");
        String referer = call.argument("referer");
        String title = call.argument("title");
        String userAgent = call.argument("userAgent");
        if(activity != null) {
          Intent intent = new Intent(Intent.ACTION_MAIN);
          intent.setClassName("teavideo.tvplayer.videoallformat", "teavideo.tvplayer.videoallformat.player.PlayerActivity");
          intent.setDataAndType(Uri.parse(url), "application/x-mpegURL");
          intent.putExtra("referer", referer);
          intent.putExtra("user_agent", userAgent);
          intent.putExtra(Intent.EXTRA_TITLE, title);
          activity.startActivity(intent);
        }
        result.success(1);
      } catch (Exception ex) {
        result.error("1", ex.getMessage(), ex.getStackTrace());
      }
    } else {
      result.notImplemented();
    }
  }

@Override public void onDetachedFromActivity() {
    
}

@Override public void onReattachedToActivityForConfigChanges(ActivityPluginBinding binding) {
    
}

@Override public void onAttachedToActivity(ActivityPluginBinding binding) {
    activity = binding.getActivity();
}

@Override public void onDetachedFromActivityForConfigChanges() {
    
}

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }
}
