import 'dart:async';

import 'package:flutter/services.dart';

class TplayerPlugin {
  static const MethodChannel _channel = const MethodChannel('tplayer_plugin');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static void openTPlayer(
      String url, String referer, String title, String userAgent) async {
    _channel.invokeMethod('openTPlayer', {
      'url': url,
      'referer': referer,
      'title': title,
      'userAgent': userAgent
    });
  }

  static void openTPlayerNoLive(
      String url, String referer, String title, String userAgent) async {
    _channel.invokeMethod('openTPlayerNoLive', {
      'url': url,
      'referer': referer,
      'title': title,
      'userAgent': userAgent
    });
  }
}
